#[repr(C)]
#[derive(Debug, Copy, Clone, bytemuck::Pod, bytemuck::Zeroable)]
pub struct Light {
    pub position: [f32; 3],
    // according to the tutorial I'm following, uniforms require 16 byte padding. So that's why this thing is here.
    _padding: u32,
    pub color: [f32; 3],
}

impl Light {
    pub fn new(position: cgmath::Vector3<f32>, color: cgmath::Vector3<f32>) -> Self {
        Self {
            position: position.into(),
            _padding: 0,
            color: color.into(),
        }
    }
}
